DERBitString (Bouncy Castle Library 1.54 API Specification)
Date: 2015-12-29

org.bouncycastle.asn1

## Class DERBitString

- java.lang.Object
- - org.bouncycastle.asn1.ASN1Object
  - - org.bouncycastle.asn1.ASN1Primitive
    - - org.bouncycastle.asn1.ASN1BitString
      - - org.bouncycastle.asn1.DERBitString

- All Implemented Interfaces:
    ASN1Encodable, ASN1String, Encodable
  Direct Known Subclasses:
    NetscapeCertType, PKIFailureInfo, ReasonFlags

      public class DERBitString
      extends ASN1BitString

  A BIT STRING with DER encoding.

- - ### Field Summary

    - ### Fields inherited from class org.bouncycastle.asn1.ASN1BitString

      `data, padBits`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `DERBitString(ASN1Encodable obj)`
    `` | `DERBitString(byte[] data)`
    `` | `DERBitString(byte[] data, int padBits)`
    `protected` | `DERBitString(byte data, int padBits)`
    `` | `DERBitString(int value)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static DERBitString` | `getInstance(ASN1TaggedObject obj, boolean explicit)` return a Bit String from a tagged object.
    `static DERBitString` | `getInstance(java.lang.Object obj)` return a Bit String from the passed in object

    - ### Methods inherited from class org.bouncycastle.asn1.ASN1BitString

      `asn1Equals, derForm, getBytes, getBytes, getLoadedObject, getOctets, getPadBits, getPadBits, getString, hashCode, intValue, toString`

    - ### Methods inherited from class org.bouncycastle.asn1.ASN1Primitive

      `equals, fromByteArray, toASN1Primitive`

    - ### Methods inherited from class org.bouncycastle.asn1.ASN1Object

      `getEncoded, getEncoded, hasEncodedTagValue, toASN1Object`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DERBitString

          protected DERBitString(byte data,
                      int padBits)

    - #### DERBitString

          public DERBitString(byte[] data,
                      int padBits)

      Parameters:
        `data` - the octets making up the bit string.
        `padBits` - the number of extra bits at the end of the string.

    - #### DERBitString

          public DERBitString(byte[] data)

    - #### DERBitString

          public DERBitString(int value)

    - #### DERBitString

          public DERBitString(ASN1Encodable obj)
                       throws java.io.IOException

      Throws:
        `java.io.IOException`

  - ### Method Detail

    - #### getInstance

          public static DERBitString getInstance(java.lang.Object obj)

      return a Bit String from the passed in object
      Parameters:
        `obj` - a DERBitString or an object that can be converted into one.
      Returns:
        a DERBitString instance, or null.
      Throws:
        `java.lang.IllegalArgumentException` - if the object cannot be converted.

    - #### getInstance

          public static DERBitString getInstance(ASN1TaggedObject obj,
                                 boolean explicit)

      return a Bit String from a tagged object.
      Parameters:
        `obj` - the tagged object holding the object we want
        `explicit` - true if the object is meant to be explicitly tagged false otherwise.
      Returns:
        a DERBitString instance, or null.
      Throws:
        `java.lang.IllegalArgumentException` - if the tagged object cannot be converted.